Index: uspace/lib/c/include/adt/list.h
===================================================================
--- uspace/lib/c/include/adt/list.h	(revision b72efe87f3e33beaa3b0d0cf7c8b598a58f6a6de)
+++ uspace/lib/c/include/adt/list.h	(revision 63f89665fc0283c1661274dc636d5a66e03d48b4)
@@ -1,5 +1,4 @@
 /*
  * Copyright (c) 2001-2004 Jakub Jermar
- * Copyright (c) 2011 Jiri Svoboda
  * All rights reserved.
  *
@@ -37,8 +36,7 @@
 #define LIBC_LIST_H_
 
-#include <assert.h>
 #include <unistd.h>
 
-/** Doubly linked list link. */
+/** Doubly linked list head and link type. */
 typedef struct link {
 	struct link *prev;  /**< Pointer to the previous item in the list. */
@@ -46,31 +44,12 @@
 } link_t;
 
-/** Doubly linked list. */
-typedef struct list {
-	link_t head;  /**< List head. Does not have any data. */
-} list_t;
-
 /** Declare and initialize statically allocated list.
  *
  * @param name Name of the new statically allocated list.
- *
- */
-#define LIST_INITIALIZE(name) \
-	list_t name = { \
-		.head = { \
-			.prev = &(name).head, \
-			.next = &(name).head \
-		} \
-	}
-
-#define list_get_instance(link, type, member) \
-	((type *) (((void *)(link)) - ((void *) &(((type *) NULL)->member))))
-
-#define list_foreach(list, iterator) \
-	for (link_t *iterator = (list).head.next; \
-	    iterator != &(list).head; iterator = iterator->next)
-
-#define assert_link_not_used(link) \
-	assert((link)->prev == NULL && (link)->next == NULL)
+ */
+#define LIST_INITIALIZE(name)  link_t name = { \
+	.prev = &name, \
+	.next = &name \
+}
 
 /** Initialize doubly-linked circular list link
@@ -79,5 +58,4 @@
  *
  * @param link Pointer to link_t structure to be initialized.
- *
  */
 static inline void link_initialize(link_t *link)
@@ -91,33 +69,10 @@
  * Initialize doubly-linked circular list.
  *
- * @param list Pointer to list_t structure.
- *
- */
-static inline void list_initialize(list_t *list)
-{
-	list->head.prev = &list->head;
-	list->head.next = &list->head;
-}
-
-/** Insert item before another item in doubly-linked circular list.
- *
- */
-static inline void list_insert_before(link_t *lnew, link_t *lold)
-{
-	lnew->next = lold;
-	lnew->prev = lold->prev;
-	lold->prev->next = lnew;
-	lold->prev = lnew;
-}
-
-/** Insert item after another item in doubly-linked circular list.
- *
- */
-static inline void list_insert_after(link_t *lnew, link_t *lold)
-{
-	lnew->prev = lold;
-	lnew->next = lold->next;
-	lold->next->prev = lnew;
-	lold->next = lnew;
+ * @param head Pointer to link_t structure representing head of the list.
+ */
+static inline void list_initialize(link_t *head)
+{
+	head->prev = head;
+	head->next = head;
 }
 
@@ -127,10 +82,12 @@
  *
  * @param link Pointer to link_t structure to be added.
- * @param list Pointer to list_t structure.
- *
- */
-static inline void list_prepend(link_t *link, list_t *list)
-{
-	list_insert_after(link, &list->head);
+ * @param head Pointer to link_t structure representing head of the list.
+ */
+static inline void list_prepend(link_t *link, link_t *head)
+{
+	link->next = head->next;
+	link->prev = head;
+	head->next->prev = link;
+	head->next = link;
 }
 
@@ -140,10 +97,24 @@
  *
  * @param link Pointer to link_t structure to be added.
- * @param list Pointer to list_t structure.
- *
- */
-static inline void list_append(link_t *link, list_t *list)
-{
-	list_insert_before(link, &list->head);
+ * @param head Pointer to link_t structure representing head of the list.
+ */
+static inline void list_append(link_t *link, link_t *head)
+{
+	link->prev = head->prev;
+	link->next = head;
+	head->prev->next = link;
+	head->prev = link;
+}
+
+/** Insert item before another item in doubly-linked circular list. */
+static inline void list_insert_before(link_t *l, link_t *r)
+{
+	list_append(l, r);
+}
+
+/** Insert item after another item in doubly-linked circular list. */
+static inline void list_insert_after(link_t *r, link_t *l)
+{
+	list_prepend(l, r);
 }
 
@@ -152,7 +123,5 @@
  * Remove item from doubly-linked circular list.
  *
- * @param link Pointer to link_t structure to be removed from the list
- *             it is contained in.
- *
+ * @param link Pointer to link_t structure to be removed from the list it is contained in.
  */
 static inline void list_remove(link_t *link)
@@ -167,37 +136,11 @@
  * Query emptiness of doubly-linked circular list.
  *
- * @param list Pointer to lins_t structure.
- *
- */
-static inline int list_empty(list_t *list)
-{
-	return (list->head.next == &list->head);
-}
-
-/** Get first item in list.
- *
- * @param list Pointer to list_t structure.
- *
- * @return Head item of the list.
- * @return NULL if the list is empty.
- *
- */
-static inline link_t *list_first(list_t *list)
-{
-	return ((list->head.next == &list->head) ? NULL : list->head.next);
-}
-
-/** Get last item in list.
- *
- * @param list Pointer to list_t structure.
- *
- * @return Head item of the list.
- * @return NULL if the list is empty.
- *
- */
-static inline link_t *list_last(list_t *list)
-{
-	return ((list->head.prev == &list->head) ? NULL : list->head.prev);
-}
+ * @param head Pointer to link_t structure representing head of the list.
+ */
+static inline int list_empty(link_t *head)
+{
+	return ((head->next == head) ? 1 : 0);
+}
+
 
 /** Split or concatenate headless doubly-linked circular list
@@ -208,9 +151,6 @@
  * concatenates splitted lists and splits concatenated lists.
  *
- * @param part1 Pointer to link_t structure leading the first
- *              (half of the headless) list.
- * @param part2 Pointer to link_t structure leading the second
- *              (half of the headless) list.
- *
+ * @param part1 Pointer to link_t structure leading the first (half of the headless) list.
+ * @param part2 Pointer to link_t structure leading the second (half of the headless) list. 
  */
 static inline void headless_list_split_or_concat(link_t *part1, link_t *part2)
@@ -225,13 +165,11 @@
 }
 
+
 /** Split headless doubly-linked circular list
  *
  * Split headless doubly-linked circular list.
  *
- * @param part1 Pointer to link_t structure leading
- *              the first half of the headless list.
- * @param part2 Pointer to link_t structure leading
- *              the second half of the headless list.
- *
+ * @param part1 Pointer to link_t structure leading the first half of the headless list.
+ * @param part2 Pointer to link_t structure leading the second half of the headless list. 
  */
 static inline void headless_list_split(link_t *part1, link_t *part2)
@@ -244,9 +182,6 @@
  * Concatenate two headless doubly-linked circular lists.
  *
- * @param part1 Pointer to link_t structure leading
- *              the first headless list.
- * @param part2 Pointer to link_t structure leading
- *              the second headless list.
- *
+ * @param part1 Pointer to link_t structure leading the first headless list.
+ * @param part2 Pointer to link_t structure leading the second headless list. 
  */
 static inline void headless_list_concat(link_t *part1, link_t *part2)
@@ -255,30 +190,9 @@
 }
 
-/** Get n-th item in a list.
- *
- * @param list Pointer to link_t structure representing the list.
- * @param n    Item number (indexed from zero).
- *
- * @return n-th item of the list.
- * @return NULL if no n-th item found.
- *
- */
-static inline link_t *list_nth(list_t *list, unsigned int n)
-{
-	unsigned int cnt = 0;
-	
-	list_foreach(*list, link) {
-		if (cnt == n)
-			return link;
-		
-		cnt++;
-	}
-	
-	return NULL;
-}
-
-extern int list_member(const link_t *, const list_t *);
-extern void list_concat(list_t *, list_t *);
-extern unsigned int list_count(const list_t *);
+#define list_get_instance(link, type, member)  ((type *) (((void *)(link)) - ((void *) &(((type *) NULL)->member))))
+
+extern int list_member(const link_t *link, const link_t *head);
+extern void list_concat(link_t *head1, link_t *head2);
+extern unsigned int list_count(const link_t *link);
 
 #endif
